/*
 * DynamicalSystem.cpp
 *
 *  Created on: Nov 13, 2012
 *      Author: romain
 */

#include "DynamicalSystem.h"

namespace nltool {


using namespace std;

DynamicalSystem::DynamicalSystem() {
}

DynamicalSystem::~DynamicalSystem() {
	// TODO Auto-generated destructor stub
}

Vector DynamicalSystem::eval(const Vector& x) {
	throw std::runtime_error(
			"No eval function implemented for the base class.");
	return Vector(dimension);
}

DynamicalSystem& DynamicalSystem::derivate(const unsigned dx) {
	throw std::runtime_error(
			"No derivate function implemented for the base class.");
	return *this;
}

//Number DynamicalSystem::maximize(const unsigned indice,
//		const Template& constraintsA, const Vector& constraintsB, Vector& pt) {
//	throw std::runtime_error(
//			"No optimization function implemented for the base class.");
//	return 0;
//}
//
//Number DynamicalSystem::minimize(const unsigned indice,
//		const Template& constraintsA, const Vector& constraintsB, Vector& pt) {
//	throw std::runtime_error(
//			"No optimization function implemented for the base class.");
//	return 0;
//}

unsigned DynamicalSystem::getDimension() const {
	return dimension;
}

void DynamicalSystem::setDimension(unsigned dimension) {
	this->dimension = dimension;
}

SystemTimeType DynamicalSystem::getSystemTimeType() const {
	return systemTimeType;
}

void DynamicalSystem::setSystemTimeType(SystemTimeType systemTimeType) {
	this->systemTimeType = systemTimeType;
}

SystemType DynamicalSystem::getSystemType() const {
	return systemType;
}

void DynamicalSystem::printType() {
	string name;
	switch (systemType) {
	case CONSTANT:
		name = "Constant";
		break;
	case LINEAR:
		name = "Linear";
		break;
	case QUADRATIC:
		name = "Quadratic";
		break;
	case POLYNOMIAL:
		name = "Polynomial";
		break;
	default:
		name = "Nonlinear";
		break;
	}
	cout << "System type: " << name << endl;
}



}  // namespace nltool
