/*
 * LinearSystem.cpp
 *
 *  Created on: Nov 13, 2012
 *      Author: romain
 */

#include "LinearSystem.h"
#include "Ball.h"

namespace nltool {


LinearSystem::LinearSystem(): inputSet(new Ball(0,0)){
	// TODO Auto-generated constructor stub

}

LinearSystem::LinearSystem(const unsigned  dim, const Matrix C, const Vector d):
						A(C), b(d),inputSet(new Ball(dim,0)) {
	dimension = dim;
	discretizedTime = false;
	systemTimeType = CONTINUOUS;
	systemType = LINEAR;
//	inputSet = *(new Ball(dim,0));
}

LinearSystem::LinearSystem(const unsigned dim, const Matrix C, const Vector d,  Set* input):
						A(C), b(d), inputSet(input){
	dimension = dim;
	discretizedTime = false;
	systemTimeType = CONTINUOUS;
	systemType = LINEAR;
}

LinearSystem::~LinearSystem() {
	// TODO Auto-generated destructor stub
	// delete &inputSet;
}

Matrix LinearSystem::getA() const
{
	return A;
}

Vector LinearSystem::getB() const
{
	return b;
}

Vector LinearSystem::eval(const Vector& x)
{
	return A*x + b;
}

void LinearSystem::setA(Matrix a)
{
	A = a;
}

Set* LinearSystem::getInputSet() const
{
    return inputSet;
}

void LinearSystem::setB(Vector b)
{
    this->b = b;
}

void LinearSystem::setInputSet(Set* inputSet)
{
    this->inputSet = inputSet;
}

//LinearSystem& LinearSystem::operator=(const LinearSystem&){
//	LinearSystem* tmp = new LinearSystem(dimension,A,b,inputSet);
//	return *tmp;
//}

}  // namespace nltool







