/*
 * ReachLinear.h
 *
 *  Created on: Nov 13, 2012
 *      Author: romain
 */

#ifndef REACHLINEAR_H_
#define REACHLINEAR_H_

#include "utils.h"
#include "LinearSystem.h"
#include "Hpolyhedron.h"

namespace nltool {


class ReachLinear {
public:
	ReachLinear();
	ReachLinear(const unsigned dim, const LinearSystem& linearSys, Number dt);
	virtual ~ReachLinear();

	Hpolyhedron reach(const Hpolyhedron& initialSet);

	Number getDiscretizationTime() const {
		return discretizationTime;
	}

	void setDiscretizationTime(Number discretizationTime) {
		this->discretizationTime = discretizationTime;
	}

	LinearSystem getLinearSystem() const {
		return linearSystem;
	}

	void setLinearSystem(LinearSystem originalSystem) {
		this->linearSystem = originalSystem;
	}

	bool isUseFixedTemplate() const {
		return useFixedTemplate;
	}

	void setUseFixedTemplate(bool useFixedTemplate) {
		this->useFixedTemplate = useFixedTemplate;
	}

private:
	LinearSystem linearSystem;
	unsigned dimension;
	Matrix Atransposed;
	Matrix eAdt;
	Matrix emATdt;
	Number discretizationTime;
	unsigned iteration;
	bool useFixedTemplate;
};


}  // namespace nltool

#endif /* REACHLINEAR_H_ */
