/*
 * ReachPolynomial.h
 *
 *  Created on: Nov 21, 2012
 *      Author: romain
 */

#ifndef REACHPOLYNOMIAL_H_
#define REACHPOLYNOMIAL_H_

#include "PolynomialSystem.h"
#include "Hpolyhedron.h"
#include "Box.h"
#include "utils.h"

namespace nltool {


class ReachPolynomial {
public:
	ReachPolynomial(PolynomialSystem &poly);
	virtual ~ReachPolynomial();

	Hpolyhedron reach(Hpolyhedron &initialSet);
	Hpolyhedron reach(Hpolyhedron &initialSet, Template& templates);

	int computeBernsteinCoef(const int dim, Polynom& poly, multiIndice& maxDegrees,
			std::vector<Number>& coef, const std::vector<Polynom> unitBoxMap);
	int computedPinv(PolynomialSystem discret);
    bool isUseNormalDynamic() const;
    void setUseNormalDynamic(bool useNormalDynamic);


    bool useNormalDynamic;
private:
	unsigned dimension;
	PolynomialSystem polySystem;


	bool useRefinement;

	// oriented bounding box
	bool dynamicBounds;
	Matrix boxRotation;
	bool firstIteration;

	// bernstein coeff interpollation
	bool interpolateCoef;
	Matrix P_inv;
	bool P_inv_computed;
	bool debugMode;
};

}  // namespace nltool

#endif /* REACHPOLYNOMIAL_H_ */
