/*
 * Simplex.h
 *
 *  Created on: Nov 21, 2012
 *      Author: romain
 */

#ifndef SIMPLEX_H_
#define SIMPLEX_H_

#include "Set.h"
#include "utils.h"
#include "DynamicalSystem.h"

namespace nltool {


class Simplex: public Set {
public:
	Simplex();
	virtual ~Simplex();
	Simplex(int dim, Vertices& vert);

	Number optimize(const Vector & direction, Vector & optPoint, bool max = true)
	{return 0;}


	int dim();
	Vertices getVertices();
	unsigned int nb_vertices();
	Vertices vertices();

	void linearInterpolation(DynamicalSystem& system, Matrix& A, Vector& b);
	bool isRegular();
	Vector centroid();
private:
	Vertices verticesData;
};

}  // namespace nltool



#endif /* SIMPLEX_H_ */

