//============================================================================
// Name        : Linear_relaxation.cpp
// Author      : Romain Testylier
// Version     :
// Copyright   : 
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <iostream>
#include <string>
#include <fstream>
#include <iomanip>
#include <stdlib.h>
#include <time.h>
//
#include <MatlabExporter.h>
//#include <PolynomialSystem.h>
#include <utils.h>
//#include <ApproximationBuilder.h>
#include <LinearSystem.h>
#include <ReachLinear.h>
#include <ReachHybridization.h>
#include <ReachPolynomial.h>
#include <test.h>
//#include <Hpolyhedron.h>
//#include <Box.h>
//#include <Simplex.h>
//#include <ReachPolynomial.h>
//
//#include <ObjExporter.h>

using namespace std;

namespace nltool {

}  // namespace nltool

using namespace nltool;
using namespace arma;

Number df(const int x, const stdVector &pt, void* data) {

	double k1 = 1.4;
	double k2 = 0.9;
	double k3 = 2.5;
	double k4 = 1.5;
	double k5 = 0.6;
	double k6 = 0.8;
	double k7 = 2.0;
	double k8 = 1.3;
	double k9 = 0.7;
	double k10 = 1.0;
	double k11 = 0.3;
	double k12 = 3.1;
	double k13 = 1.8;
	double k14 = 1.5;

	switch (x) {
	case 0:
		return k1 * pt[2] - k2 * pt[0];
		break;
	case 1:
		return k3 * pt[4] - k4 * pt[1];
		break;
	case 2:
		return k5 * pt[6] - k6 * pt[2] * pt[1];
		break;
	case 3:
		return k7 - k8 * pt[3] * pt[2];
		break;
	case 4:
		return k9 * pt[0] - k10 * pt[3] * pt[4];
		break;
	case 5:
		return k11 * pt[0] - k12 * pt[5];
		break;
	case 6:
		return k13 * pt[5] - k14 * pt[6] * pt[1];
		break;

	}
}

string dyctios_str() {

	double k1 = 1.4;
	double k2 = 0.9;
	double k3 = 2.5;
	double k4 = 1.5;
	double k5 = 0.6;
	double k6 = 0.8;
	double k7 = 2.0;
	double k8 = 1.3;
	double k9 = 0.7;
	double k10 = 1.0;
	double k11 = 0.3;
	double k12 = 3.1;
	double k13 = 1.8;
	double k14 = 1.5;

	ostringstream str;
	str << "x0' = " << k1 << "*x2 - " << k2 << "*x0" << endl;
	str << "x1' = " << k3 << "*x4 - " << k4 << "*x1" << endl;
	str << "x2' = " << k5 << "*x6 - " << k6 << "*x2*x1" << endl;
	str << "x3' = " << k7 << " - " << k8 << "*x3*x2" << endl;
	str << "x4' = " << k9 << "*x0 - " << k10 << "*x3*x4" << endl;
	str << "x5' = " << k11 << "*x0 - " << k12 << "*x5" << endl;
	str << "x6' = " << k13 << "*x5 - " << k14 << "*x6*x1";

	return str.str();
}

Number hess(const int x, const stdVector &pt, const int dx, const int dy,
		void* data) {
	double k1 = 1.4;
	double k2 = 0.9;
	double k3 = 2.5;
	double k4 = 1.5;
	double k5 = 0.6;
	double k6 = 0.8;
	double k7 = 2.0;
	double k8 = 1.3;
	double k9 = 0.7;
	double k10 = 1.0;
	double k11 = 0.3;
	double k12 = 3.1;
	double k13 = 1.8;
	double k14 = 1.5;
	if ((x == 2) && (((dx == 2) && (dy == 1)) || ((dx == 1) && (dy == 2))))
		return -k6;
	if ((x == 3) && (((dx == 2) && (dy == 3)) || ((dx == 3) && (dy == 2))))
		return -k8;
	if ((x == 4) && (((dx == 3) && (dy == 4)) || ((dx == 4) && (dy == 3))))
		return -k10;
	if ((x == 6) && (((dx == 6) && (dy == 1)) || ((dx == 1) && (dy == 6))))
		return -k14;
	return 0;

}


void dyctios_hybridization() {
	int dim = 7;
	std::vector<int> projection(2); // specifiy the projected variables
	projection[0] = 4;
	projection[1] = 6;
	ostringstream oss;
	oss << "dictyos_hybridi_x" << projection[0] << "x" << projection[1] << ".m";
	string filename = oss.str();
	Number dt = 0.007;
	int nbIter = 4000;
	double error = 0.025;
	Chrono chrono;

	Vector translation(dim);

	translation[0] = 1.2;
	translation[1] = 1.05;
	translation[2] = 1.5;
	translation[3] = 2.4;
	translation[4] = 1.0;
	translation[5] = 0.1;
	translation[6] = 0.45;

	Template tmpTemplate;
	Vector tmpCoef;
	Number radius = 0.0001;
	createOctagonalSet(dim, radius, translation, tmpTemplate, tmpCoef);
	Hpolyhedron initialSet(dim, tmpTemplate, tmpCoef);

//	stdVector initBl(dim, 1.2);
//	stdVector initBu(dim, 1.25);
//
//	initBl[1] = 1.05;
//	initBu[1] = 1.1;
//	initBl[2] = 1.5;
//	initBu[2] = 1.55;
//	initBl[3] = 2.4;
//	initBu[3] = 2.45;
//	initBl[4] = 1.0;
//	initBu[4] = 1.05;
//	initBl[5] = 0.1;
//	initBu[5] = 0.15;
//	initBl[6] = 0.45;
//	initBu[6] = 0.5;

//	Box initialSetTmp(initBl, initBu);
//	Hpolyhedron initialSet(initialSetTmp);

	PointerSystem ptrSys(dim, df, NULL, hess, NULL, false);
	ReachHybridization reachHybridization(
			static_cast<DynamicalSystem*>(&ptrSys), initialSet, error, dt);

	chrono.start();
	reachHybridization.reach(nbIter);
	Number time = chrono.stop();
	cout << "duration: " << time << " s" << endl;

	vector<Hpolyhedron> result = reachHybridization.getReachabilityResult();
	// exporting results

	vector<Hpolyhedron> approximationDomains =
			reachHybridization.getDomainsCreated();

	stdVector color(3, 0);
	color[0] = 1;

	stdVector exporterBl, exporterBu = stdVector(dim);
	Template approxTemplate = createTemplateApproximation(dim, 8, projection[0],
			projection[1]);
	Template approxTemplateDomains = createTemplateApproximation(dim, 12,
			projection[0], projection[1]);

	MatlabExporter exporter(dim, filename, exporterBl, exporterBu, projection);

	exporter.setApproximationTemplate(approxTemplateDomains);
	int displayEvery = 8;

	for (unsigned i = 0; i < approximationDomains.size(); i += displayEvery)
		exporter.save(approximationDomains[i]);

	exporter.setApproximationTemplate(approxTemplate);

	cout << "nb Simplex created: " << approximationDomains.size() << endl;

	exporter.setApproximationTemplate(approxTemplate);
	exporter.findBounds(approximationDomains);
	for (unsigned i = 0; i < result.size(); i += displayEvery)
		exporter.save(result[i], color);
	//exporter.saveVectorField(linearSys);
}

void dyctios_bernstein() {
	int dim = 7;
	std::vector<int> projection(2); // specifiy the projected variables
	projection[0] = 4;
	projection[1] = 6;
	ostringstream oss;
	oss << "dictyos_bern_x" << projection[0] << "x" << projection[1] << ".m";
	string filename = oss.str();
	Number dt = 0.028;
	int nbIter = 1000;
	double error = 0.025;
	Chrono chrono;

	Vector translation(dim);
	translation[0] = 1.2;
	translation[1] = 1.05;
	translation[2] = 1.5;
	translation[3] = 2.4;
	translation[4] = 1.0;
	translation[5] = 0.1;
	translation[6] = 0.45;

	Template tmpTemplate;
	Vector tmpCoef;
	Number radius = 0.0001;
//		createOctagonalSet(dim, radius, translation, tmpTemplate, tmpCoef);
//		Hpolyhedron initialSet(dim, tmpTemplate, tmpCoef);

	stdVector bl = arma::conv_to<stdVector>::from(translation - radius);
	stdVector bu = arma::conv_to<stdVector>::from(translation + radius);
	Box tmpBox(bl, bu);
	Hpolyhedron initialSet(tmpBox);

	//	Vector translation = arma::ones(dim);
//	Template tmpTemplate;
//	Vector tmpCoef;
//	Number radius = 0.01;
//	createOctagonalSet(dim,radius,translation,tmpTemplate, tmpCoef);
//	Hpolyhedron initialSet(dim, tmpTemplate, tmpCoef);

	string systemStr = dyctios_str();
	PolynomialSystem polySys(dim, systemStr);
	polySys = polySys.getDiscretizedSystem(dt);

	cout << "polysys: " << polySys << endl;

	cout << "initialSet" << initialSet << endl;

	ReachPolynomial reachPoly(polySys);
//	reachPoly.useNormalDynamic = true;
	vector<Hpolyhedron> result;
	result.push_back(initialSet);

	chrono.start();

	for (unsigned i = 0; i < nbIter; i++) {
		cout << "iteration " << i << endl;
		Hpolyhedron res = reachPoly.reach(result[result.size() - 1]);
		Box tmpBox = res.getBbox();
//		if ((tmpBox.getMinInterval()) < 1e-5) {
//			cout << "inflate!" << endl;
//			// inflate the result
//			res.inflate(0.0001);
//		}

		result.push_back(res);

	}
	Number time = chrono.stop();
	cout << "duration: " << time << " s" << endl;
	// exporting results

	stdVector color(3, 0);
	color[1] = 1;
	stdVector exporterBl, exporterBu = stdVector(dim);
	Template approxTemplate = createTemplateApproximation(dim, 4, projection[0],
			projection[1]);
	MatlabExporter exporter(dim, filename, exporterBl, exporterBu, projection);

	//exporter.setApproximationTemplate(approxTemplate);
	exporter.findBounds(result);
	int displayEvery = 3;
	for (unsigned i = 0; i < result.size(); i += displayEvery) {
		exporter.save(result[i]);
	}
	//exporter.saveVectorField(linearSys);
}

int main(int argc, char **argv) {
	//testPolynomialMethod();
	//dyctios_hybridization();
	dyctios_bernstein();
	cout << "DONE!!" << endl;
	return 0;
}
